package com.szyd.setting;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.CheckedTextView;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.GridView;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.szyd.uhfdemo.MyApp;
import com.szyd.uhfdemo.R;
import com.szyd.util.MLog;
import com.szyd.util.MUtil;

import java.util.HashSet;

/**
 * author CYD
 * date 2018/11/22
 * email cyd19950902@qq.com
 */
public class PoweFrequencyFragment extends Fragment implements View.OnClickListener {

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.port_adress_setting, container, false);
    }

    private Spinner powerGet, area_frequency, sesionMode;

    private EditText inventory_time, sleep_time;
    private CheckBox poweroff_save;

    private TextView showNeedList;

    private int[] cn_920 = {922375, 921125, 924125, 920875, 921875, 921375, 923875, 922625, 923125, 924375, 922125, 923375, 920625, 921625, 923625, 922875};
    private int[] cn_840 = {842375, 841125, 844125, 840875, 841875, 841375, 843875, 842625, 843125, 844375, 842125, 843375, 840625, 841625, 843625, 842875};
    private int[] eu = {867500, 866300, 865700, 866900};
    private int[] fixFreq_915 = {915000};
    private int[] us = {915750, 927250, 902750, 915250, 903250, 926750, 910750, 922750, 906750, 926250, 904250, 920250, 919250, 909250, 918750, 917750,
            905250, 904750, 925250, 921750, 914750, 913750, 922250, 911250, 911750, 903750, 908750, 905750, 912250, 906250, 917250, 914250, 907250, 918250,
            916250, 910250, 907750, 924750, 909750, 919750, 916750, 913250, 923750, 908250, 925750, 912750, 924250, 921250, 920750, 923250};

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        showNeedList = view.findViewById(R.id.showNeedList);
        powerGet = view.findViewById(R.id.powerGet);
        area_frequency = view.findViewById(R.id.area_frequency);
        sesionMode = view.findViewById(R.id.sesionMode);
        ((CheckBox) view.findViewById(R.id.soundSwitch)).setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                MyApp.ifOpenSound = isChecked;
            }
        });

        view.findViewById(R.id.setPower).setOnClickListener(this);
        view.findViewById(R.id.getPower).setOnClickListener(this);
        view.findViewById(R.id.set_area_frequency).setOnClickListener(this);
        view.findViewById(R.id.get_area_frequency).setOnClickListener(this);
        view.findViewById(R.id.set_session_mode).setOnClickListener(this);
        view.findViewById(R.id.get_session_mode).setOnClickListener(this);
        view.findViewById(R.id.set_frq_rang).setOnClickListener(this);
        view.findViewById(R.id.get_frq_rang).setOnClickListener(this);

        inventory_time = view.findViewById(R.id.inventory_time);
        sleep_time = view.findViewById(R.id.sleep_time);
        poweroff_save = view.findViewById(R.id.poweroff_save);
        view.findViewById(R.id.set_inventory_time).setOnClickListener(this);
        view.findViewById(R.id.get_inventory_time).setOnClickListener(this);

        Integer[] powerData = new Integer[26];
        for (int i = 5; i <= 30; i++) {
            powerData[i - 5] = i;
        }

        ArrayAdapter adapter = new ArrayAdapter(getActivity(), android.R.layout.simple_spinner_item, powerData);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        powerGet.setAdapter(adapter);

        // initPower();
        // getAreaFrequency();
    }

    //获取功率
    private boolean initPower() {
        int power = MyApp.getMyApp().getIdataLib().powerGet();
        if (power >= 5) {
            powerGet.setSelection(power - 5);
            MLog.e("power = " + power);
            return true;
        }
        return false;
    }

    //获取区域频率
    private boolean getAreaFrequency() {
        int area_fq = MyApp.getMyApp().getIdataLib().frequencyModeGet();
        boolean areaFQFlag = area_fq >= 0 && area_fq <= 4;
        if (areaFQFlag)
            area_frequency.setSelection(area_fq);
        return areaFQFlag;
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.setPower: // 设置功率
                int value = (int) powerGet.getSelectedItem();
                MLog.e("vauel = " + value);
                boolean ifValue = MyApp.getMyApp().getIdataLib().powerSet(value);
                setResult(ifValue);
                break;
            case R.id.getPower:
                setResult(initPower());
                break;
            case R.id.set_area_frequency:  //设置区域频率
                int postion = area_frequency.getSelectedItemPosition();
                boolean ifSetAreaFQ = MyApp.getMyApp().getIdataLib().frequencyModeSet(postion);
                setResult(ifSetAreaFQ);
                break;
            case R.id.get_area_frequency:
                setResult(getAreaFrequency());
                break;
            case R.id.set_session_mode:
                int vals = sesionMode.getSelectedItemPosition();
                setResult(MyApp.getMyApp().getIdataLib().sessionModeSet(vals));
                break;
            case R.id.get_session_mode:
                int sMode = MyApp.getMyApp().getIdataLib().sessionModeGet(); //session模式
                boolean modeGetFlag = sMode > -1 && sMode < 4;
                if (modeGetFlag) {
                    sesionMode.setSelection(sMode);
                }
                System.currentTimeMillis();
                setResult(modeGetFlag);
                break;
            case R.id.set_inventory_time:
                String iTime = inventory_time.getText().toString();
                String sTime = sleep_time.getText().toString();
                if (TextUtils.isEmpty(iTime) || TextUtils.isEmpty(sTime)) {
                    MUtil.show(R.string.time_empty_notice);
                } else {
                    boolean ifCheck = poweroff_save.isChecked();
                    MUtil.show("ifCheck = " + ifCheck);

                    boolean flag = MyApp.getMyApp().getIdataLib().inventoryWaitTime_Set(Integer.parseInt(iTime), Integer.parseInt(sTime), ifCheck);
                    setResult(flag);
                }
                break;
            case R.id.get_inventory_time:
                int[] times = MyApp.getMyApp().getIdataLib().inventoryWaitTime_Get();
                if (times == null) {
                    setResult(false);
                } else {
                    inventory_time.setText(times[0] + "");
                    sleep_time.setText(times[1] + "");
                }
                break;
            case R.id.set_frq_rang:
                selectFrq();
                //int[] frqRangs = {922375, 921125, 924125, 920875}; //测试用的频点
                break;
            case R.id.get_frq_rang:
                showNeedList.setText(null);//清空数据
                int[] getFrqRange = null; //当前实际设置的频点
                getFrqRange = MyApp.getMyApp().getIdataLib().frequenceRange_Get();
                if (getFrqRange == null) {
                    setResult(false);
                    return;
                }
                for (int i = 0; i < getFrqRange.length; i++) {
                    if (i < getFrqRange.length - 1)
                        showNeedList.append(getFrqRange[i] + ",");
                    else
                        showNeedList.append(getFrqRange[i] + "");
                }
                setResult(true);
                break;
        }

    }


    private AlertDialog ad;
    private HashSet<Integer> hSet = new HashSet();  //存放选中下标
    private int[] getFrqRange = null;  //存放当前区域频率的所有频点

    //设置需要的频点
    private void selectFrq() {
        getFrqRange = null;
        int area_fq = MyApp.getMyApp().getIdataLib().frequencyModeGet();
        switch (area_fq) {
            case 0:
                getFrqRange = cn_840;
                break;
            case 1:
                getFrqRange = cn_920;
                break;
            case 2:
                getFrqRange = eu;
                break;
            case 3:
                getFrqRange = fixFreq_915;
                break;
            case 4:
                getFrqRange = us;
                break;
        }
        //  getFrqRange = MyApp.getMyApp().getIdataLib().frequenceRange_Get();
        if (getFrqRange != null) {
            hSet.clear();
            ad = new AlertDialog.Builder(getContext()).create();
            ad.setTitle("当前可选择的频点范围");
            GridView gd = new GridView(getContext());
            gd.setChoiceMode(AbsListView.CHOICE_MODE_MULTIPLE);
            gd.setNumColumns(3);
            Integer getFrqRanges[] = new Integer[getFrqRange.length];
            for (int i = 0; i < getFrqRange.length; i++) {
                getFrqRanges[i] = getFrqRange[i];
            }
            ArrayAdapter adapter = new ArrayAdapter(getContext(), android.R.layout.simple_list_item_single_choice, getFrqRanges);
            gd.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                    CheckedTextView cb = view.findViewById(android.R.id.text1);
                    if (cb.isChecked())
                        hSet.add(position);
                    else
                        hSet.remove(position);
                }
            });
            gd.setAdapter(adapter);
            ad.setView(gd);
            ad.setButton(DialogInterface.BUTTON_POSITIVE, "确定", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    int[] frqSel = new int[hSet.size()]; //实际选中的频点
                    int i = 0;
                    for (Integer integer : hSet) {
                        frqSel[i] = getFrqRange[integer];
                        i++;
                    }
                    boolean ifsuccess = MyApp.getMyApp().getIdataLib().frequenceRange_Set(frqSel.length, frqSel, false);
                    setResult(ifsuccess);
                }
            });
            ad.setButton(DialogInterface.BUTTON_NEGATIVE, "取消", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    ad.dismiss();
                }
            });

            ad.create();
            ad.show();
        }
    }


    private void setResult(boolean flag) {
        if (flag) {
            MUtil.show(R.string.success);
        } else {
            MUtil.show(R.string.failed);
        }
    }

}
