package com.szyd.util;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.szyd.uhfdemo.R;

import java.util.List;
import java.util.Map;

/**
 * author CYD
 * date 2018/11/21
 * email chengyd@idatachina.com
 */
public class DataAdapter extends BaseAdapter {

    private Context con;
    private Map<String, Integer> realDataMap;
    private List<String> realKeyList;

    public DataAdapter(Context con, Map<String, Integer> realDataMap, List<String> realKeyList) {
        this.con = con;
        this.realDataMap = realDataMap;
        this.realKeyList = realKeyList;
    }


    @Override
    public int getCount() {
        return realKeyList.size();
    }

    @Override
    public Object getItem(int position) {
        return realKeyList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View v, ViewGroup parent) {
        ViewHolder vh;
        if (v == null) {
            v = LayoutInflater.from(con).inflate(R.layout.item, null);
            vh = new ViewHolder();
            vh.epc = v.findViewById(R.id.epc);
            vh.count = v.findViewById(R.id.count);
            vh.sn = v.findViewById(R.id.sn);
            v.setTag(vh);
        } else {
            vh = (ViewHolder) v.getTag();
        }
        String epc = realKeyList.get(position);
        String readNumber = String.valueOf(realDataMap.get(epc));
        vh.sn.setText((position + 1) + "");
        vh.epc.setText(epc);
        vh.count.setText(readNumber);
        return v;
    }

    private class ViewHolder {
        private TextView sn, epc, count;
    }
}
